/* THIS FILE IS AUTOGENERATED FROM CaretStateChangedEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_CaretStateChangedEventBinding_h
#define mozilla_dom_CaretStateChangedEventBinding_h

#include "EventBinding.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

class CaretStateChangedEvent;
struct CaretStateChangedEventAtoms;
struct CaretStateChangedEventInitAtoms;
class DOMRectReadOnly;
struct NativePropertyHooks;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

enum class CaretChangedReason : uint8_t {
  Visibilitychange,
  Updateposition,
  Longpressonemptycontent,
  Taponcaret,
  Presscaret,
  Releasecaret,
  Scroll,
  EndGuard_
};

namespace CaretChangedReasonValues {
extern const EnumEntry strings[8];

static constexpr size_t Count = 7;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(CaretChangedReason::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(CaretChangedReason stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace CaretChangedReasonValues

bool
ToJSValue(JSContext* aCx, CaretChangedReason aArgument, JS::MutableHandle<JS::Value> aValue);


struct CaretStateChangedEventInit : public EventInit
{
  MOZ_INIT_OUTSIDE_CTOR RefPtr<mozilla::dom::DOMRectReadOnly> mBoundingClientRect;
  MOZ_INIT_OUTSIDE_CTOR bool mCaretVisible;
  MOZ_INIT_OUTSIDE_CTOR bool mCaretVisuallyVisible;
  MOZ_INIT_OUTSIDE_CTOR bool mCollapsed;
  MOZ_INIT_OUTSIDE_CTOR CaretChangedReason mReason;
  MOZ_INIT_OUTSIDE_CTOR nsString mSelectedTextContent;
  MOZ_INIT_OUTSIDE_CTOR bool mSelectionEditable;
  MOZ_INIT_OUTSIDE_CTOR bool mSelectionVisible;

  CaretStateChangedEventInit();

  explicit inline CaretStateChangedEventInit(const FastDictionaryInitializer& )
    : EventInit(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline CaretStateChangedEventInit(const CaretStateChangedEventInit& aOther)
    : EventInit(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mBoundingClientRect, "mBoundingClientRect", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mBoundingClientRect);
  }

  CaretStateChangedEventInit&
  operator=(const CaretStateChangedEventInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, CaretStateChangedEventInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastCaretStateChangedEventInit : public CaretStateChangedEventInit
{
  inline FastCaretStateChangedEventInit()
    : CaretStateChangedEventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace CaretStateChangedEvent_Binding {

  typedef mozilla::dom::CaretStateChangedEvent NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::CaretStateChangedEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::CaretStateChangedEvent,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::CaretStateChangedEvent,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace CaretStateChangedEvent_Binding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_CaretStateChangedEventBinding_h
