/* THIS FILE IS AUTOGENERATED FROM PannerNode.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_PannerNodeBinding_h
#define mozilla_dom_PannerNodeBinding_h

#include "AudioNodeBinding.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class PannerNode;
struct PannerNodeAtoms;
struct PannerOptionsAtoms;
class ProtoAndIfaceCache;

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {

enum class PanningModelType : uint8_t {
  Equalpower,
  HRTF,
  EndGuard_
};

namespace PanningModelTypeValues {
extern const EnumEntry strings[3];

static constexpr size_t Count = 2;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(PanningModelType::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(PanningModelType stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace PanningModelTypeValues

bool
ToJSValue(JSContext* aCx, PanningModelType aArgument, JS::MutableHandle<JS::Value> aValue);


enum class DistanceModelType : uint8_t {
  Linear,
  Inverse,
  Exponential,
  EndGuard_
};

namespace DistanceModelTypeValues {
extern const EnumEntry strings[4];

static constexpr size_t Count = 3;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(DistanceModelType::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(DistanceModelType stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace DistanceModelTypeValues

bool
ToJSValue(JSContext* aCx, DistanceModelType aArgument, JS::MutableHandle<JS::Value> aValue);


struct PannerOptions : public AudioNodeOptions
{
  MOZ_INIT_OUTSIDE_CTOR double mConeInnerAngle;
  MOZ_INIT_OUTSIDE_CTOR double mConeOuterAngle;
  MOZ_INIT_OUTSIDE_CTOR double mConeOuterGain;
  MOZ_INIT_OUTSIDE_CTOR DistanceModelType mDistanceModel;
  MOZ_INIT_OUTSIDE_CTOR double mMaxDistance;
  MOZ_INIT_OUTSIDE_CTOR float mOrientationX;
  MOZ_INIT_OUTSIDE_CTOR float mOrientationY;
  MOZ_INIT_OUTSIDE_CTOR float mOrientationZ;
  MOZ_INIT_OUTSIDE_CTOR PanningModelType mPanningModel;
  MOZ_INIT_OUTSIDE_CTOR float mPositionX;
  MOZ_INIT_OUTSIDE_CTOR float mPositionY;
  MOZ_INIT_OUTSIDE_CTOR float mPositionZ;
  MOZ_INIT_OUTSIDE_CTOR double mRefDistance;
  MOZ_INIT_OUTSIDE_CTOR double mRolloffFactor;

  PannerOptions();

  explicit inline PannerOptions(const FastDictionaryInitializer& )
    : AudioNodeOptions(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline PannerOptions(const PannerOptions& aOther)
    : AudioNodeOptions(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  PannerOptions&
  operator=(const PannerOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, PannerOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastPannerOptions : public PannerOptions
{
  inline FastPannerOptions()
    : PannerOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace PannerNode_Binding {

  typedef mozilla::dom::PannerNode NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::PannerNode* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  // We declare this as an array so that retrieving a pointer to this
  // binding's property hooks only requires compile/link-time resolvable
  // address arithmetic.  Declaring it as a pointer instead would require
  // doing a run-time load to fetch a pointer to this binding's property
  // hooks.  And then structures which embedded a pointer to this structure
  // would require a run-time load for proper initialization, which would
  // then induce static constructors.  Lots of static constructors.
  extern const NativePropertyHooks sNativePropertyHooks[];

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::PannerNode,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::PannerNode,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace PannerNode_Binding



} // namespace dom
} // namespace mozilla

#endif // mozilla_dom_PannerNodeBinding_h
