// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_Metrics_h
#define mozilla_Metrics_h

#include "mozilla/glean/bindings/MetricTypes.h"
#include "mozilla/Tuple.h"
#include "mozilla/Maybe.h"
#include "nsTArray.h"
#include "nsPrintfCString.h"

namespace mozilla::glean {
struct NoExtraKeys;

namespace fog {
    /**
     * generated from fog.initialization
     */
    /**
     * Time the FOG initialization takes.
     */
    constexpr impl::TimespanMetric initialization(1);

    /**
     * generated from fog.failed_idle_registration
     */
    /**
     * True if we failed to register with the idle service. Absent otherwise.
     * Means IPC probably isn't working well.
     * Child-process data will likely be absent, or incomplete.
     */
    constexpr impl::BooleanMetric failed_idle_registration(2);

}
namespace fog_ipc {
    /**
     * generated from fog.ipc.replay_failures
     */
    /**
     * The number of times the ipc buffer failed to be replayed in the
     * parent process.
     */
    constexpr impl::CounterMetric replay_failures(3);

    /**
     * generated from fog.ipc.buffer_sizes
     */
    /**
     * The number and size of the IPC buffers being received over FOG IPC.
     */
    constexpr impl::MemoryDistributionMetric buffer_sizes(4);

    /**
     * generated from fog.ipc.flush_durations
     */
    /**
     * The length of time between asking the child processes for their
     * IPC buffers and all of them being received by the parent.
     */
    constexpr impl::TimingDistributionMetric flush_durations(5);

}
namespace test_only {
    /**
     * generated from test_only.bad_code
     */
    /**
     * Number of times we encountered bad code.
     * This is a test-only metric.
     */
    constexpr impl::CounterMetric bad_code(6);

    /**
     * generated from test_only.can_we_time_it
     */
    /**
     * Test metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric can_we_time_it(7);

    /**
     * generated from test_only.cheesy_string
     */
    /**
     * Only the cheesiest of strings.
     * This is a test-only metric.
     */
    constexpr impl::StringMetric cheesy_string(8);

    /**
     * generated from test_only.cheesy_string_list
     */
    /**
     * Only the cheesiest of strings. In list form!
     * This is a test-only metric.
     */
    constexpr impl::StringListMetric cheesy_string_list(9);

    /**
     * generated from test_only.what_a_date
     */
    /**
     * ...To be writing FOG code. This is a test-only metric.
     */
    constexpr impl::DatetimeMetric what_a_date(10);

    /**
     * generated from test_only.what_id_it
     */
    /**
     * Just a UUID.
     * This is a test-only metric.
     */
    constexpr impl::UuidMetric what_id_it(11);

    /**
     * generated from test_only.can_we_flag_it
     */
    /**
     * Test metric for a boolean.
     * This is a test-only metric.
     */
    constexpr impl::BooleanMetric can_we_flag_it(12);

    /**
     * generated from test_only.do_you_remember
     */
    /**
     * They say it's the second thing to go.
     * This is a test-only metric.
     */
    constexpr impl::MemoryDistributionMetric do_you_remember(13);

    /**
     * generated from test_only.what_time_is_it
     */
    /**
     * Adheres to at least two of the top ten fallacies programmers believe
     * about time.
     * This is a test-only metric.
     */
    constexpr impl::TimingDistributionMetric what_time_is_it(14);

    /**
     * generated from test_only.mabels_kitchen_counters
     */
    /**
     * Counts Mabels labeled by their kitchen counters.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::CounterMetric> mabels_kitchen_counters(15);

    /**
     * generated from test_only.mabels_bathroom_counters
     */
    /**
     * Counts Mabels labeled by their bathroom counters.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::CounterMetric> mabels_bathroom_counters(16);

    /**
     * generated from test_only.mabels_like_balloons
     */
    /**
     * Does the labeled Mabel like balloons?
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::BooleanMetric> mabels_like_balloons(17);

    /**
     * generated from test_only.mabels_balloon_strings
     */
    /**
     * What do the labeled Mabel's liked balloons' strings say?
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::StringMetric> mabels_balloon_strings(18);

    /**
     * generated from test_only.mirror_time
     */
    /**
     * Mirrored metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric mirror_time(19);

    /**
     * generated from test_only.mirror_time_nanos
     */
    /**
     * Mirrored metric for a timespan.
     * This is a test-only metric.
     */
    constexpr impl::TimespanMetric mirror_time_nanos(20);

    /**
     * generated from test_only.mirrors_for_labeled_bools
     */
    /**
     * Mirrored metric.
     * This is a test-only metric.
     */
    constexpr impl::Labeled<impl::BooleanMetric> mirrors_for_labeled_bools(21);

    /**
     * generated from test_only.one_ping_one_bool
     */
    /**
     * One bool for one ping only.
     * This is a test-only metric.
     */
    constexpr impl::BooleanMetric one_ping_one_bool(22);

    /**
     * generated from test_only.meaning_of_life
     */
    /**
     * Measures the one true answer to the Ultimate Question of Life,
     * the Universe, and Everything.
     * Approximately.
     * This is a test-only metric.
     */
    constexpr impl::QuantityMetric meaning_of_life(23);

}
namespace test_only_ipc {
    /**
     * generated from test_only.ipc.a_counter
     */
    /**
     * This is a test-only metric.
     * Just counting things.
     */
    constexpr impl::CounterMetric a_counter(24);

    /**
     * generated from test_only.ipc.a_bool
     */
    /**
     * This is a test-only metric.
     * Just flagging things.
     */
    constexpr impl::BooleanMetric a_bool(25);

    /**
     * generated from test_only.ipc.a_date
     */
    /**
     * This is a test-only metric.
     * Just putting things on the calendar.
     */
    constexpr impl::DatetimeMetric a_date(26);

    /**
     * generated from test_only.ipc.a_string
     */
    /**
     * This is a test-only metric.
     * Just setting some strings.
     */
    constexpr impl::StringMetric a_string(27);

    /**
     * generated from test_only.ipc.a_memory_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring memory.
     */
    constexpr impl::MemoryDistributionMetric a_memory_dist(28);

    /**
     * generated from test_only.ipc.a_timing_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring time.
     */
    constexpr impl::TimingDistributionMetric a_timing_dist(29);

    /**
     * generated from test_only.ipc.a_custom_dist
     */
    /**
     * This is a test-only metric.
     * Just measuring samples.
     */
    constexpr impl::CustomDistributionMetric a_custom_dist(30);

    /**
     * generated from test_only.ipc.a_string_list
     */
    /**
     * This is a test-only metric.
     * Just appending some strings.
     */
    constexpr impl::StringListMetric a_string_list(31);

    /**
     * generated from test_only.ipc.an_event
     */
    struct AnEventExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<nsCString> extra2;

      Tuple<nsTArray<uint32_t>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<uint32_t> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement(0);
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement(1);
          extraValues.EmplaceBack(extra2.value());
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This is a test-only metric.
     * Just recording some events.
     */
    constexpr impl::EventMetric<AnEventExtra> an_event(32);

    /**
     * generated from test_only.ipc.event_with_extra
     */
    struct EventWithExtraExtra {
      mozilla::Maybe<nsCString> extra1;
      mozilla::Maybe<uint32_t> extra2;
      mozilla::Maybe<bool> extra3LongerName;

      Tuple<nsTArray<uint32_t>, nsTArray<nsCString>> ToFfiExtra() const {
        nsTArray<uint32_t> extraKeys;
        nsTArray<nsCString> extraValues;
        if (extra1) {
          extraKeys.AppendElement(0);
          extraValues.EmplaceBack(extra1.value());
        }
        if (extra2) {
          extraKeys.AppendElement(1);
          extraValues.EmplaceBack(nsPrintfCString("%d", extra2.value()));
        }
        if (extra3LongerName) {
          extraKeys.AppendElement(2);
          extraValues.AppendElement()->AssignASCII(extra3LongerName.value() ? "true" : "false");
        }
        return MakeTuple(std::move(extraKeys), std::move(extraValues));
      }
    };
    /**
     * This is a test-only metric.
     * Just recording some events.
     */
    constexpr impl::EventMetric<EventWithExtraExtra> event_with_extra(33);

    /**
     * generated from test_only.ipc.no_extra_event
     */
    /**
     * This is a test-only metric.
     * Just recording some events without the extra fuss.
     */
    constexpr impl::EventMetric<NoExtraKeys> no_extra_event(34);

    /**
     * generated from test_only.ipc.a_uuid
     */
    /**
     * This is a test-only metric.
     * Just recording some unique identifiers.
     */
    constexpr impl::UuidMetric a_uuid(35);

    /**
     * generated from test_only.ipc.a_labeled_counter
     */
    /**
     * This is a test-only metric.
     * Just counting labeled things.
     */
    constexpr impl::Labeled<impl::CounterMetric> a_labeled_counter(36);

    /**
     * generated from test_only.ipc.a_quantity
     */
    /**
     * This is a test-only metric.
     * Just quantifying things.
     */
    constexpr impl::QuantityMetric a_quantity(37);

}
namespace background_update {
    /**
     * generated from background_update.client_id
     */
    /**
     * The Telemetry client ID of the default profile.
     */
    constexpr impl::UuidMetric client_id(38);

    /**
     * generated from background_update.final_state
     */
    /**
     * String description of the final state the update state machine reached.
     */
    constexpr impl::StringMetric final_state(39);

    /**
     * generated from background_update.states
     */
    /**
     * Ordered list of string descriptions of the states that the update state machine
     * reached.
     */
    constexpr impl::StringListMetric states(40);

    /**
     * generated from background_update.reasons
     */
    /**
     * List of reasons that the background update task did not run.
     */
    constexpr impl::StringListMetric reasons(41);

    /**
     * generated from background_update.exit_code_success
     */
    /**
     * True if the exit code/status of the background update task is 0, which means
     * success.
     */
    constexpr impl::BooleanMetric exit_code_success(42);

    /**
     * generated from background_update.exit_code_exception
     */
    /**
     * True if the exit code/status of the background update task is 3, which means an
     * exception was thrown.
     */
    constexpr impl::BooleanMetric exit_code_exception(43);

}
namespace update {
    /**
     * generated from update.service_enabled
     */
    /**
     * Preference "app.update.service.enabled": whether the Mozilla Maintenance
     * Service is enabled.
     */
    constexpr impl::BooleanMetric service_enabled(44);

    /**
     * generated from update.auto_download
     */
    /**
     * Per-installation preference "app.update.auto": whether to fetch and install
     * updates without user intervention.
     */
    constexpr impl::BooleanMetric auto_download(45);

    /**
     * generated from update.background_update
     */
    /**
     * Per-installation preference "app.update.background.enabled": whether to fetch
     * and install updates in the background when Firefox is not running.
     */
    constexpr impl::BooleanMetric background_update(46);

    /**
     * generated from update.enabled
     */
    /**
     * True when policies are disabled or when the "DisableAppUpdate" is not in
     * effect.
     */
    constexpr impl::BooleanMetric enabled(47);

    /**
     * generated from update.channel
     */
    /**
     * The update channel.
     */
    constexpr impl::StringMetric channel(48);

    /**
     * generated from update.can_usually_apply_updates
     */
    /**
     * Whether or not the Update Service can usually download and install updates. See
     * `canUsuallyApplyUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_apply_updates(49);

    /**
     * generated from update.can_usually_check_for_updates
     */
    /**
     * Whether or not the Update Service can usually check for updates. See
     * `canUsuallyCheckForUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_check_for_updates(50);

    /**
     * generated from update.can_usually_stage_updates
     */
    /**
     * Whether the Update Service is usually able to stage updates. See
     * `canUsuallyStageUpdates` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_stage_updates(51);

    /**
     * generated from update.can_usually_use_bits
     */
    /**
     * On Windows, whether the Update Service can usually use BITS. See
     * `canUsuallyUseBits` in https://searchfox.org/mozilla-
     * central/source/toolkit/mozapps/update/nsIUpdateService.idl.
     */
    constexpr impl::BooleanMetric can_usually_use_bits(52);

}
namespace browser_ui {
    /**
     * generated from browser.ui.proton_enabled
     */
    /**
     * True if the Proton default theme is enabled.
     */
    constexpr impl::BooleanMetric proton_enabled(53);

}

} // namespace mozilla::glean

#endif // mozilla_Metrics_h
