//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/cache/CacheParent.h"

#include "mozilla/ipc/PBackgroundParent.h"
#include "mozilla/dom/cache/PCacheOpParent.h"
#include "mozilla/dom/cache/PCacheStreamControlParent.h"
#include "mozilla/ipc/PFileDescriptorSetParent.h"
#include "mozilla/ipc/PChildToParentStreamParent.h"
#include "mozilla/ipc/PParentToChildStreamParent.h"

#include "ipc/IPCMessageUtils.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheParent::RecvPCacheOpConstructor(
        PCacheOpParent* actor,
        const CacheOpArgs& aOpArgs) -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PCacheParent::PCacheParent() :
    mozilla::ipc::IProtocol(PCacheMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PCacheParent);
}

PCacheParent::~PCacheParent()
{
    MOZ_COUNT_DTOR(PCacheParent);
}

auto PCacheParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PCacheParent::ManagedPCacheOpParent(nsTArray<PCacheOpParent*>& aArr) const -> void
{
    mManagedPCacheOpParent.ToArray(aArr);
}

auto PCacheParent::ManagedPCacheOpParent() const -> const ManagedContainer<PCacheOpParent>&
{
    return mManagedPCacheOpParent;
}

auto PCacheParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPCacheOpParent.Count();
    arr__.SetCapacity(total);

    for (auto* key : mManagedPCacheOpParent) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

}

auto PCacheParent::OpenPCacheOpEndpoint(PCacheOpParent* aActor) -> ManagedEndpoint<PCacheOpChild>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpParent actor");
        return ManagedEndpoint<PCacheOpChild>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPCacheOpParent.Insert(aActor);

    return ManagedEndpoint<PCacheOpChild>(mozilla::ipc::PrivateIPDLInterface(), aActor->Id());
}

auto PCacheParent::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpParent> aEndpoint,
        PCacheOpParent* aActor) -> bool
{
    MOZ_RELEASE_ASSERT(aEndpoint.ActorId(), "Invalid Endpoint!");
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpParent actor");
        return false;
    }

    aActor->SetManagerAndRegister(this, *aEndpoint.ActorId());
    mManagedPCacheOpParent.Insert(aActor);

    return true;
}

auto PCacheParent::Send__delete__(PCacheParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PCache::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCache::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PCacheMsgStart, actor);
    return sendok__;
}

auto PCacheParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
{
            PCacheOpParent* actor = static_cast<PCacheOpParent*>(aListener);

            const bool removed = mManagedPCacheOpParent.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PCacheParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        static_cast<CacheParent*>(this)->DeallocPCacheOpParent(static_cast<PCacheOpParent*>(aListener));
        return;
    default:
        FatalError("unreached");
        return;
    }
}

auto PCacheParent::OnMessageReceived(const Message& msg__) -> PCacheParent::Result
{
    switch (msg__.type()) {
    case PCache::Msg_PCacheOpConstructor__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCache::Msg_PCacheOpConstructor", OTHER);

            PickleIterator iter__{msg__};
            ActorHandle handle__{};
            CacheOpArgs aOpArgs{};

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(handle__)))))) {
                FatalError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ActorHandle'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(aOpArgs)))))) {
                FatalError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            // Sentinel = 'aOpArgs'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 173212334)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'CacheOpArgs'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            PCacheOpParent* actor = (static_cast<CacheParent*>(this))->AllocPCacheOpParent(aOpArgs);
            if (!actor) {
                NS_WARNING("Cannot bind null PCacheOpParent actor");
                return MsgValueError;
            }

            actor->SetManagerAndRegister(this, (handle__).mId);
            mManagedPCacheOpParent.Insert(actor);

            if ((!((static_cast<CacheParent*>(this))->RecvPCacheOpConstructor(std::move(actor), std::move(aOpArgs))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCache::Msg_Teardown__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCache::Msg_Teardown", OTHER);

            if ((!((static_cast<CacheParent*>(this))->RecvTeardown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PCache::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PCacheParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheParent::Result
{
    return MsgNotKnown;
}

auto PCacheParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheParent::ClearSubtree() -> void
{
    for (auto* key : mManagedPCacheOpParent) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPCacheOpParent) {
        // Recursively releasing mManagedPCacheOpParent kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPCacheOpParent.Clear();

}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PCache", PCacheMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::cache::PCacheParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
