//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/cache/PCacheStorageChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/cache/CacheStorageChild.h"

#include "mozilla/ipc/PBackgroundChild.h"
#include "mozilla/dom/cache/PCacheChild.h"
#include "mozilla/dom/cache/PCacheOpChild.h"
#include "mozilla/dom/cache/PCacheStreamControlChild.h"
#include "mozilla/ipc/PFileDescriptorSetChild.h"
#include "mozilla/ipc/PChildToParentStreamChild.h"
#include "mozilla/ipc/PParentToChildStreamChild.h"

#include "ipc/IPCMessageUtils.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {
namespace cache {


auto PCacheStorageChild::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PCacheStorageChild::PCacheStorageChild() :
    mozilla::ipc::IProtocol(PCacheStorageMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PCacheStorageChild);
}

PCacheStorageChild::~PCacheStorageChild()
{
    MOZ_COUNT_DTOR(PCacheStorageChild);
}

auto PCacheStorageChild::Manager() const -> PBackgroundChild*
{
    return static_cast<PBackgroundChild*>(IProtocol::Manager());
}

auto PCacheStorageChild::ManagedPCacheOpChild(nsTArray<PCacheOpChild*>& aArr) const -> void
{
    mManagedPCacheOpChild.ToArray(aArr);
}

auto PCacheStorageChild::ManagedPCacheOpChild() const -> const ManagedContainer<PCacheOpChild>&
{
    return mManagedPCacheOpChild;
}

auto PCacheStorageChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    total += mManagedPCacheOpChild.Count();
    arr__.SetCapacity(total);

    for (auto* key : mManagedPCacheOpChild) {
        arr__.AppendElement(key->GetLifecycleProxy());
    }

}

auto PCacheStorageChild::OpenPCacheOpEndpoint(PCacheOpChild* aActor) -> ManagedEndpoint<PCacheOpParent>
{
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpChild actor");
        return ManagedEndpoint<PCacheOpParent>();
    }

    aActor->SetManagerAndRegister(this);
    mManagedPCacheOpChild.Insert(aActor);

    return ManagedEndpoint<PCacheOpParent>(mozilla::ipc::PrivateIPDLInterface(), aActor->Id());
}

auto PCacheStorageChild::BindPCacheOpEndpoint(
        ManagedEndpoint<PCacheOpChild> aEndpoint,
        PCacheOpChild* aActor) -> bool
{
    MOZ_RELEASE_ASSERT(aEndpoint.ActorId(), "Invalid Endpoint!");
    if (!aActor) {
        NS_WARNING("Cannot bind null PCacheOpChild actor");
        return false;
    }

    aActor->SetManagerAndRegister(this, *aEndpoint.ActorId());
    mManagedPCacheOpChild.Insert(aActor);

    return true;
}

auto PCacheStorageChild::SendPCacheOpConstructor(const CacheOpArgs& aOpArgs) -> PCacheOpChild*
{
    PCacheOpChild* actor = (static_cast<CacheStorageChild*>(this))->AllocPCacheOpChild(aOpArgs);
    return SendPCacheOpConstructor(actor, aOpArgs);
}

auto PCacheStorageChild::SendPCacheOpConstructor(
        PCacheOpChild* actor,
        const CacheOpArgs& aOpArgs) -> PCacheOpChild*
{
    if (!actor) {
        NS_WARNING("Cannot bind null PCacheOpChild actor");
        return nullptr;
    }

    actor->SetManagerAndRegister(this);
    mManagedPCacheOpChild.Insert(actor);


    // Build our constructor message.
    IPC::Message* msg__ = PCacheStorage::Msg_PCacheOpConstructor(Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, this, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(102892058);
    WriteIPDLParam(msg__, this, aOpArgs);
    // Sentinel = 'aOpArgs'
    (msg__)->WriteSentinel(173212334);




    // Notify the other side about the newly created actor. This can
    // fail if our manager has already been destroyed.
    //
    // NOTE: If the send call fails due to toplevel channel teardown,
    // the `IProtocol::ChannelSend` wrapper absorbs the error for us,
    // so we don't tear down actors unexpectedly.

    if (mozilla::ipc::LoggingEnabledFor("PCacheStorageChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStorageChild",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStorage::Msg_PCacheOpConstructor", OTHER);

    bool sendok__ = ChannelSend(msg__);


    // Warn, destroy the actor, and return null if the message failed to
    // send. Otherwise, return the successfully created actor reference.
    if (!sendok__) {
        NS_WARNING("Error sending PCacheOpChild constructor");
        IProtocol* mgr = actor->Manager();
        actor->DestroySubtree(FailedConstructor);
        actor->ClearSubtree();
        mgr->RemoveManagee(PCacheOpMsgStart, actor);

        return nullptr;
    }
    return actor;
}

auto PCacheStorageChild::SendTeardown() -> bool
{
    IPC::Message* msg__ = PCacheStorage::Msg_Teardown(Id());





    if (mozilla::ipc::LoggingEnabledFor("PCacheStorageChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PCacheStorageChild",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PCacheStorage::Msg_Teardown", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PCacheStorageChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
{
            PCacheOpChild* actor = static_cast<PCacheOpChild*>(aListener);

            const bool removed = mManagedPCacheOpChild.EnsureRemoved(actor);
            MOZ_RELEASE_ASSERT(removed, "actor not managed by this!");

            auto* proxy = actor->GetLifecycleProxy();
            NS_IF_RELEASE(proxy);
            return;
        }    default:
FatalError("unreached");
        return;    }
}

auto PCacheStorageChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    switch (aProtocolId) {
    case PCacheOpMsgStart:
        static_cast<CacheStorageChild*>(this)->DeallocPCacheOpChild(static_cast<PCacheOpChild*>(aListener));
        return;
    default:
        FatalError("unreached");
        return;
    }
}

auto PCacheStorageChild::OnMessageReceived(const Message& msg__) -> PCacheStorageChild::Result
{
    switch (msg__.type()) {
    case PCacheStorage::Reply_PCacheOpConstructor__ID:
        {
            return MsgProcessed;
        }
    case PCacheStorage::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PCacheStorageChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PCacheStorageChild",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PCacheStorage::Msg___delete__", OTHER);

            PickleIterator iter__{msg__};
            PCacheStorageChild* actor{};

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(actor)))))) {
                FatalError("Error deserializing 'PCacheStorage'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PCacheStorage'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PCacheStorage'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((static_cast<CacheStorageChild*>(this))->Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = actor->Manager();
            actor->DestroySubtree(Deletion);
            actor->ClearSubtree();
            mgr->RemoveManagee(PCacheStorageMsgStart, actor);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PCacheStorageChild::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageChild::Result
{
    return MsgNotKnown;
}

auto PCacheStorageChild::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PCacheStorageChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PCacheStorageChild::ClearSubtree() -> void
{
    for (auto* key : mManagedPCacheOpChild) {
        key->ClearSubtree();
    }
    for (auto* key : mManagedPCacheOpChild) {
        // Recursively releasing mManagedPCacheOpChild kids.
        auto* proxy = key->GetLifecycleProxy();
        NS_IF_RELEASE(proxy);
    }
    mManagedPCacheOpChild.Clear();

}



} // namespace cache
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::cache::PCacheStorageChild*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::dom::cache::PCacheStorageChild*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PCacheStorage", PCacheStorageMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::cache::PCacheStorageChild*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
