//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PDNSRequestParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/net/DNSRequestParent.h"
#include "mozilla/net/NeckoMessageUtils.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/net/PSocketProcessParent.h"

#include "ipc/IPCMessageUtils.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


auto PDNSRequestParent::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PDNSRequestParent::PDNSRequestParent() :
    mozilla::ipc::IProtocol(PDNSRequestMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PDNSRequestParent);
}

PDNSRequestParent::~PDNSRequestParent()
{
    MOZ_COUNT_DTOR(PDNSRequestParent);
}

auto PDNSRequestParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PDNSRequestParent::SendCancelDNSRequest(
        const nsCString& hostName,
        const nsCString& trrServer,
        const uint16_t& type,
        const OriginAttributes& originAttributes,
        const uint32_t& flags,
        const nsresult& reason) -> bool
{
    IPC::Message* msg__ = PDNSRequest::Msg_CancelDNSRequest(Id());

    WriteIPDLParam(msg__, this, hostName);
    // Sentinel = 'hostName'
    (msg__)->WriteSentinel(249627456);
    WriteIPDLParam(msg__, this, trrServer);
    // Sentinel = 'trrServer'
    (msg__)->WriteSentinel(320603088);
    WriteIPDLParam(msg__, this, type);
    // Sentinel = 'type'
    (msg__)->WriteSentinel(75760067);
    WriteIPDLParam(msg__, this, originAttributes);
    // Sentinel = 'originAttributes'
    (msg__)->WriteSentinel(947259056);
    WriteIPDLParam(msg__, this, flags);
    // Sentinel = 'flags'
    (msg__)->WriteSentinel(102171150);
    WriteIPDLParam(msg__, this, reason);
    // Sentinel = 'reason'
    (msg__)->WriteSentinel(148112009);




    if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PDNSRequestParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PDNSRequest::Msg_CancelDNSRequest", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PDNSRequestParent::Send__delete__(PDNSRequestParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PDNSRequest::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PDNSRequestParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PDNSRequest::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PDNSRequestMsgStart, actor);
    return sendok__;
}

auto PDNSRequestParent::SendLookupCompleted(const DNSRequestResponse& reply) -> bool
{
    IPC::Message* msg__ = PDNSRequest::Msg_LookupCompleted(Id());

    WriteIPDLParam(msg__, this, reply);
    // Sentinel = 'reply'
    (msg__)->WriteSentinel(108266029);




    if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PDNSRequestParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PDNSRequest::Msg_LookupCompleted", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PDNSRequestParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PDNSRequestParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PDNSRequestParent::OnMessageReceived(const Message& msg__) -> PDNSRequestParent::Result
{
    switch (msg__.type()) {
    case PDNSRequest::Msg_CancelDNSRequest__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PDNSRequestParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PDNSRequest::Msg_CancelDNSRequest", OTHER);

            PickleIterator iter__{msg__};
            nsCString hostName{};
            nsCString trrServer{};
            uint16_t type{};
            OriginAttributes originAttributes{};
            uint32_t flags{};
            nsresult reason{};

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(hostName)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'hostName'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 249627456)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(trrServer)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'trrServer'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 320603088)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(type)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            // Sentinel = 'type'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 75760067)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(originAttributes)))))) {
                FatalError("Error deserializing 'OriginAttributes'");
                return MsgValueError;
            }
            // Sentinel = 'originAttributes'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 947259056)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'OriginAttributes'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(flags)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'flags'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 102171150)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(reason)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            // Sentinel = 'reason'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 148112009)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((static_cast<DNSRequestParent*>(this))->RecvCancelDNSRequest(std::move(hostName), std::move(trrServer), std::move(type), std::move(originAttributes), std::move(flags), std::move(reason))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PDNSRequest::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PDNSRequest::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PDNSRequestParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PDNSRequest::Msg___delete__", OTHER);

            PickleIterator iter__{msg__};
            PDNSRequestParent* actor{};

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(actor)))))) {
                FatalError("Error deserializing 'PDNSRequest'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PDNSRequest'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PDNSRequest'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((static_cast<DNSRequestParent*>(this))->Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = actor->Manager();
            actor->DestroySubtree(Deletion);
            actor->ClearSubtree();
            mgr->RemoveManagee(PDNSRequestMsgStart, actor);

            return MsgProcessed;
        }
    case PDNSRequest::Msg_LookupCompleted__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PDNSRequestParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PDNSRequestParent",
                    OtherPid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PDNSRequest::Msg_LookupCompleted", OTHER);

            PickleIterator iter__{msg__};
            DNSRequestResponse reply{};

            if ((!(ReadIPDLParam((&(msg__)), (&(iter__)), this, (&(reply)))))) {
                FatalError("Error deserializing 'DNSRequestResponse'");
                return MsgValueError;
            }
            // Sentinel = 'reply'
            if ((!(((&(msg__)))->ReadSentinel((&(iter__)), 108266029)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'DNSRequestResponse'");
                return MsgValueError;
            }
            msg__.EndRead(iter__, msg__.type());
            if ((!((static_cast<DNSRequestParent*>(this))->RecvLookupCompleted(std::move(reply))))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PDNSRequestParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PDNSRequestParent::Result
{
    return MsgNotKnown;
}

auto PDNSRequestParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PDNSRequestParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PDNSRequestParent::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::net::PDNSRequestParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::net::PDNSRequestParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PDNSRequest", PDNSRequestMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PDNSRequestParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
