//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PTRRServiceParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/net/TRRServiceParent.h"

#include "mozilla/net/PSocketProcessParent.h"

#include "ipc/IPCMessageUtils.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


MOZ_IMPLICIT PTRRServiceParent::PTRRServiceParent() :
    mozilla::ipc::IProtocol(PTRRServiceMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PTRRServiceParent);
}

PTRRServiceParent::~PTRRServiceParent()
{
    MOZ_COUNT_DTOR(PTRRServiceParent);
}

auto PTRRServiceParent::Manager() const -> PSocketProcessParent*
{
    return static_cast<PSocketProcessParent*>(IProtocol::Manager());
}

auto PTRRServiceParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PTRRServiceParent::Send__delete__(PTRRServiceParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    IPC::Message* msg__ = PTRRService::Msg___delete__((actor)->Id());

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    WriteIPDLParam(msg__, actor, actor);
    // Sentinel = 'actor'
    (msg__)->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PTRRServiceParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTRRServiceParent",
            (actor)->OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTRRService::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(msg__);

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PTRRServiceMsgStart, actor);
    return sendok__;
}

auto PTRRServiceParent::SendUpdatePlatformDNSInformation(const nsTArray<nsCString>& aSuffixList) -> bool
{
    IPC::Message* msg__ = PTRRService::Msg_UpdatePlatformDNSInformation(Id());

    WriteIPDLParam(msg__, this, aSuffixList);
    // Sentinel = 'aSuffixList'
    (msg__)->WriteSentinel(438174835);




    if (mozilla::ipc::LoggingEnabledFor("PTRRServiceParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTRRServiceParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTRRService::Msg_UpdatePlatformDNSInformation", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PTRRServiceParent::SendUpdateParentalControlEnabled(const bool& aEnabled) -> bool
{
    IPC::Message* msg__ = PTRRService::Msg_UpdateParentalControlEnabled(Id());

    WriteIPDLParam(msg__, this, aEnabled);
    // Sentinel = 'aEnabled'
    (msg__)->WriteSentinel(224789261);




    if (mozilla::ipc::LoggingEnabledFor("PTRRServiceParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTRRServiceParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTRRService::Msg_UpdateParentalControlEnabled", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PTRRServiceParent::SendClearDNSCache(const bool& aTrrToo) -> bool
{
    IPC::Message* msg__ = PTRRService::Msg_ClearDNSCache(Id());

    WriteIPDLParam(msg__, this, aTrrToo);
    // Sentinel = 'aTrrToo'
    (msg__)->WriteSentinel(183567052);




    if (mozilla::ipc::LoggingEnabledFor("PTRRServiceParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTRRServiceParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTRRService::Msg_ClearDNSCache", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PTRRServiceParent::SendSetDetectedTrrURI(const nsCString& aURI) -> bool
{
    IPC::Message* msg__ = PTRRService::Msg_SetDetectedTrrURI(Id());

    WriteIPDLParam(msg__, this, aURI);
    // Sentinel = 'aURI'
    (msg__)->WriteSentinel(57934162);




    if (mozilla::ipc::LoggingEnabledFor("PTRRServiceParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTRRServiceParent",
            OtherPid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTRRService::Msg_SetDetectedTrrURI", OTHER);

    bool sendok__ = ChannelSend(msg__);
    return sendok__;
}

auto PTRRServiceParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTRRServiceParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTRRServiceParent::OnMessageReceived(const Message& msg__) -> PTRRServiceParent::Result
{
    switch (msg__.type()) {
    case PTRRService::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PTRRServiceParent::OnMessageReceived(
        const Message& msg__,
        Message*& reply__) -> PTRRServiceParent::Result
{
    return MsgNotKnown;
}

auto PTRRServiceParent::OnCallReceived(
        const Message& msg__,
        Message*& reply__) -> PTRRServiceParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PTRRServiceParent::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::net::PTRRServiceParent*>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aActor->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    WriteIPDLParam(aMsg, aActor, id);
}

auto IPDLParamTraits<mozilla::net::PTRRServiceParent*>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aActor->ReadActor(aMsg, aIter, true, "PTRRService", PTRRServiceMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PTRRServiceParent*>(actor.value());
    return true;
}

} // namespace ipc
} // namespace mozilla
