//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundStorageParent_h
#define PBackgroundStorageParent_h

#include "mozilla/dom/PBackgroundStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/OriginAttributes.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PBackgroundStorageParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef mozilla::OriginAttributesPattern OriginAttributesPattern;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

protected:
    virtual mozilla::ipc::IPCResult
    RecvDeleteMe() = 0;
    virtual mozilla::ipc::IPCResult
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncGetUsage(const nsCString& scope) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAsyncFlush() = 0;
    virtual mozilla::ipc::IPCResult
    RecvStartup() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearAll() = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOrigin(const nsCString& originNoSuffix) = 0;
    virtual mozilla::ipc::IPCResult
    RecvClearMatchingOriginAttributes(const OriginAttributesPattern& pattern) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PBackgroundStorageParent();

    virtual ~PBackgroundStorageParent();

public:
    PBackgroundParent*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    [[nodiscard]] static bool
    Send__delete__(PBackgroundStorageParent* actor);

    [[nodiscard]] bool
    SendObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope);

    [[nodiscard]] bool
    SendOriginsHavingData(const nsTArray<nsCString>& origins);

    [[nodiscard]] bool
    SendLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    [[nodiscard]] bool
    SendLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv);

    [[nodiscard]] bool
    SendLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    [[nodiscard]] bool
    SendError(const nsresult& rv);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

private:
    void
    ClearSubtree();

};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PBackgroundStorageParent*>
{
    typedef mozilla::dom::PBackgroundStorageParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PBackgroundStorageParent_h
