//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PChromiumCDMChild_h
#define PChromiumCDMChild_h

#include "mozilla/gmp/PChromiumCDM.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "gmp-sanitized-cdm-exports.h"

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PChromiumCDMChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef cdm::HdcpVersion HdcpVersion;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef mozilla::gmp::NodeIdParts NodeIdParts;
    typedef mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;

public:
    typedef std::function<void(const bool&)> InitResolver;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInit(
            const bool& aAllowDistinctiveIdentifier,
            const bool& aAllowPersistentState,
            InitResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetStatusForPolicy(
            const uint32_t& aPromiseId,
            const HdcpVersion& aMinHdcpVersion) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetServerCertificate(
            const uint32_t& aPromiseId,
            nsTArray<uint8_t>&& aServerCert) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCreateSessionAndGenerateRequest(
            const uint32_t& aPromiseId,
            const uint32_t& aSessionType,
            const uint32_t& aInitDataType,
            nsTArray<uint8_t>&& aInitData) = 0;
    virtual mozilla::ipc::IPCResult
    RecvLoadSession(
            const uint32_t& aPromiseId,
            const uint32_t& aSessionType,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            nsTArray<uint8_t>&& aResponse) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCompleteQueryOutputProtectionStatus(
            const bool& aSuccess,
            const uint32_t& aLinkMask,
            const uint32_t& aProtectionMask) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecrypt(
            const uint32_t& aId,
            const CDMInputBuffer& aBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInitializeVideoDecoder(const CDMVideoDecoderConfig& aConfig) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDeinitializeVideoDecoder() = 0;
    virtual mozilla::ipc::IPCResult
    RecvResetVideoDecoder() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDecryptAndDecodeFrame(const CDMInputBuffer& aBuffer) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDrain() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDestroy() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGiveBuffer(Shmem&& aShmem) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPurgeShmems() = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PChromiumCDMChild();

    virtual ~PChromiumCDMChild();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    PGMPContentChild*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    static bool
    Send__delete__(PChromiumCDMChild* actor);

    bool
    SendOnResolvePromiseWithKeyStatus(
            const uint32_t& aPromiseId,
            const uint32_t& aKeyStatus);

    bool
    SendOnResolveNewSessionPromise(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    bool
    SendOnResolvePromise(const uint32_t& aPromiseId);

    bool
    SendOnRejectPromise(
            const uint32_t& aPromiseId,
            const uint32_t& aException,
            const uint32_t& aSystemCode,
            const nsCString& aErrorMessage);

    bool
    SendOnSessionMessage(
            const nsCString& aSessionId,
            const uint32_t& aMessageType,
            const nsTArray<uint8_t>& aMessage);

    bool
    SendOnSessionKeysChange(
            const nsCString& aSessionId,
            const nsTArray<CDMKeyInformation>& aKeysInfo);

    bool
    SendOnExpirationChange(
            const nsCString& aSessionId,
            const double& aSecondsSinceEpoch);

    bool
    SendOnSessionClosed(const nsCString& aSessionId);

    bool
    SendOnQueryOutputProtectionStatus();

    bool
    SendResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccessful);

    bool
    SendDecrypted(
            const uint32_t& aId,
            const uint32_t& aStatus,
            Shmem&& aDecryptedData);

    bool
    SendDecryptFailed(
            const uint32_t& aId,
            const uint32_t& aStatus);

    bool
    SendOnDecoderInitDone(const uint32_t& aStatus);

    bool
    SendDecodedShmem(
            const CDMVideoFrame& aFrame,
            Shmem&& aData);

    bool
    SendDecodedData(
            const CDMVideoFrame& aFrame,
            const nsTArray<uint8_t>& aData);

    bool
    SendDecodeFailed(const uint32_t& aStatus);

    bool
    SendResetVideoDecoderComplete();

    bool
    SendDrainComplete();

    bool
    SendShutdown();

    bool
    SendIncreaseShmemPoolSize();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

private:
    void
    ClearSubtree();

};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PChromiumCDMChild*>
{
    typedef mozilla::gmp::PChromiumCDMChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PChromiumCDMChild_h
