//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PChromiumCDMParent_h
#define PChromiumCDMParent_h

#include "mozilla/gmp/PChromiumCDM.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "gmp-sanitized-cdm-exports.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PChromiumCDMParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gmp::PGMPContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gmp::CDMInputBuffer CDMInputBuffer;
    typedef mozilla::gmp::CDMKeyInformation CDMKeyInformation;
    typedef mozilla::gmp::CDMVideoDecoderConfig CDMVideoDecoderConfig;
    typedef mozilla::gmp::CDMVideoFrame CDMVideoFrame;
    typedef mozilla::gmp::CDMVideoPlane CDMVideoPlane;
    typedef cdm::EncryptionScheme EncryptionScheme;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef cdm::HdcpVersion HdcpVersion;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef mozilla::gmp::NodeIdParts NodeIdParts;
    typedef mozilla::gmp::NodeIdVariant NodeIdVariant;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

public:
    typedef MozPromise<bool, ResponseRejectReason, true> InitPromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PChromiumCDMParent();

    virtual ~PChromiumCDMParent();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    PGMPContentParent*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    void
    SendInit(
            const bool& aAllowDistinctiveIdentifier,
            const bool& aAllowPersistentState,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    [[nodiscard]] RefPtr<InitPromise>
    SendInit(
            const bool& aAllowDistinctiveIdentifier,
            const bool& aAllowPersistentState);

    [[nodiscard]] bool
    SendGetStatusForPolicy(
            const uint32_t& aPromiseId,
            const HdcpVersion& aMinHdcpVersion);

    [[nodiscard]] bool
    SendSetServerCertificate(
            const uint32_t& aPromiseId,
            const nsTArray<uint8_t>& aServerCert);

    [[nodiscard]] bool
    SendCreateSessionAndGenerateRequest(
            const uint32_t& aPromiseId,
            const uint32_t& aSessionType,
            const uint32_t& aInitDataType,
            const nsTArray<uint8_t>& aInitData);

    [[nodiscard]] bool
    SendLoadSession(
            const uint32_t& aPromiseId,
            const uint32_t& aSessionType,
            const nsCString& aSessionId);

    [[nodiscard]] bool
    SendUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aResponse);

    [[nodiscard]] bool
    SendCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    [[nodiscard]] bool
    SendRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    [[nodiscard]] bool
    SendCompleteQueryOutputProtectionStatus(
            const bool& aSuccess,
            const uint32_t& aLinkMask,
            const uint32_t& aProtectionMask);

    [[nodiscard]] bool
    SendDecrypt(
            const uint32_t& aId,
            const CDMInputBuffer& aBuffer);

    [[nodiscard]] bool
    SendInitializeVideoDecoder(const CDMVideoDecoderConfig& aConfig);

    [[nodiscard]] bool
    SendDeinitializeVideoDecoder();

    [[nodiscard]] bool
    SendResetVideoDecoder();

    [[nodiscard]] bool
    SendDecryptAndDecodeFrame(const CDMInputBuffer& aBuffer);

    [[nodiscard]] bool
    SendDrain();

    [[nodiscard]] bool
    SendDestroy();

    [[nodiscard]] bool
    SendGiveBuffer(Shmem&& aShmem);

    [[nodiscard]] bool
    SendPurgeShmems();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

private:
    void
    ClearSubtree();

};


} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gmp::PChromiumCDMParent*>
{
    typedef mozilla::gmp::PChromiumCDMParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PChromiumCDMParent_h
