enum class PhaseKind : uint8_t {
  FIRST,
  MUTATOR = FIRST,
  GC_BEGIN,
  MARK_CCWS,
  MARK_STACK,
  MARK_RUNTIME_DATA,
  MARK_EMBEDDING,
  MARK_COMPARTMENTS,
  MARK_ROOTS,
  EVICT_NURSERY_FOR_MAJOR_GC,
  WAIT_BACKGROUND_THREAD,
  UNMARK,
  UNMARK_WEAKMAPS,
  BUFFER_GRAY_ROOTS,
  MARK_DISCARD_CODE,
  RELAZIFY_FUNCTIONS,
  PURGE,
  PURGE_PROP_MAP_TABLES,
  PURGE_SOURCE_URLS,
  JOIN_PARALLEL_TASKS,
  PREPARE,
  MARK_DELAYED,
  MARK,
  SWEEP_MARK_INCOMING_BLACK,
  SWEEP_MARK_GRAY_WEAK,
  SWEEP_MARK_WEAK,
  SWEEP_MARK_INCOMING_GRAY,
  SWEEP_MARK_GRAY,
  SWEEP_MARK,
  WEAK_ZONES_CALLBACK,
  WEAK_COMPARTMENT_CALLBACK,
  FINALIZE_START,
  UPDATE_ATOMS_BITMAP,
  SWEEP_ATOMS_TABLE,
  SWEEP_DISCARD_CODE,
  SWEEP_INNER_VIEWS,
  SWEEP_CC_WRAPPER,
  SWEEP_BASE_SHAPE,
  SWEEP_INITIAL_SHAPE,
  SWEEP_REGEXP,
  SWEEP_COMPRESSION,
  SWEEP_WEAKMAPS,
  SWEEP_UNIQUEIDS,
  SWEEP_FINALIZATION_REGISTRIES,
  SWEEP_WEAKREFS,
  SWEEP_JIT_DATA,
  SWEEP_WEAK_CACHES,
  SWEEP_MISC,
  SWEEP_COMPARTMENTS,
  SWEEP_OBJECT,
  SWEEP_STRING,
  SWEEP_SCRIPT,
  SWEEP_SCOPE,
  SWEEP_REGEXP_SHARED,
  SWEEP_SHAPE,
  SWEEP_PROP_MAP,
  FINALIZE_END,
  DESTROY,
  SWEEP,
  COMPACT_MOVE,
  COMPACT_UPDATE_CELLS,
  COMPACT_UPDATE,
  COMPACT,
  DECOMMIT,
  GC_END,
  MINOR_GC,
  EVICT_NURSERY,
  TRACE_HEAP,
  UNMARK_GRAY,
  BARRIER,
  LIMIT,
  NONE = LIMIT,
  EXPLICIT_SUSPENSION = LIMIT,
  IMPLICIT_SUSPENSION
};

enum class Phase : uint8_t {
  FIRST,
  MUTATOR = FIRST,
  GC_BEGIN,
  EVICT_NURSERY_FOR_MAJOR_GC,
  MARK_ROOTS_1,
  MARK_CCWS_1,
  MARK_STACK_1,
  MARK_RUNTIME_DATA_1,
  MARK_EMBEDDING_1,
  MARK_COMPARTMENTS_1,
  WAIT_BACKGROUND_THREAD,
  PREPARE,
  UNMARK,
  UNMARK_WEAKMAPS,
  BUFFER_GRAY_ROOTS,
  MARK_DISCARD_CODE,
  RELAZIFY_FUNCTIONS,
  PURGE,
  PURGE_PROP_MAP_TABLES,
  PURGE_SOURCE_URLS,
  JOIN_PARALLEL_TASKS_1,
  MARK,
  MARK_ROOTS_2,
  MARK_CCWS_2,
  MARK_STACK_2,
  MARK_RUNTIME_DATA_2,
  MARK_EMBEDDING_2,
  MARK_COMPARTMENTS_2,
  MARK_DELAYED_1,
  SWEEP,
  SWEEP_MARK,
  MARK_DELAYED_2,
  SWEEP_MARK_INCOMING_BLACK,
  SWEEP_MARK_WEAK,
  MARK_DELAYED_3,
  SWEEP_MARK_GRAY_WEAK,
  SWEEP_MARK_INCOMING_GRAY,
  SWEEP_MARK_GRAY,
  FINALIZE_START,
  WEAK_ZONES_CALLBACK,
  WEAK_COMPARTMENT_CALLBACK,
  UPDATE_ATOMS_BITMAP,
  SWEEP_ATOMS_TABLE,
  SWEEP_COMPARTMENTS,
  SWEEP_DISCARD_CODE,
  SWEEP_INNER_VIEWS,
  SWEEP_CC_WRAPPER,
  SWEEP_BASE_SHAPE,
  SWEEP_INITIAL_SHAPE,
  SWEEP_REGEXP,
  SWEEP_COMPRESSION,
  SWEEP_WEAKMAPS,
  SWEEP_UNIQUEIDS,
  SWEEP_FINALIZATION_REGISTRIES,
  SWEEP_WEAKREFS,
  SWEEP_JIT_DATA,
  SWEEP_WEAK_CACHES,
  SWEEP_MISC,
  JOIN_PARALLEL_TASKS_2,
  SWEEP_OBJECT,
  SWEEP_STRING,
  SWEEP_SCRIPT,
  SWEEP_SCOPE,
  SWEEP_REGEXP_SHARED,
  SWEEP_SHAPE,
  SWEEP_PROP_MAP,
  FINALIZE_END,
  DESTROY,
  JOIN_PARALLEL_TASKS_3,
  COMPACT,
  COMPACT_MOVE,
  COMPACT_UPDATE,
  MARK_ROOTS_3,
  MARK_CCWS_3,
  MARK_STACK_3,
  MARK_RUNTIME_DATA_3,
  MARK_EMBEDDING_3,
  MARK_COMPARTMENTS_3,
  COMPACT_UPDATE_CELLS,
  JOIN_PARALLEL_TASKS_4,
  DECOMMIT,
  GC_END,
  MINOR_GC,
  MARK_ROOTS_4,
  MARK_CCWS_4,
  MARK_STACK_4,
  MARK_RUNTIME_DATA_4,
  MARK_EMBEDDING_4,
  MARK_COMPARTMENTS_4,
  EVICT_NURSERY,
  MARK_ROOTS_5,
  MARK_CCWS_5,
  MARK_STACK_5,
  MARK_RUNTIME_DATA_5,
  MARK_EMBEDDING_5,
  MARK_COMPARTMENTS_5,
  TRACE_HEAP,
  MARK_ROOTS_6,
  MARK_CCWS_6,
  MARK_STACK_6,
  MARK_RUNTIME_DATA_6,
  MARK_EMBEDDING_6,
  MARK_COMPARTMENTS_6,
  BARRIER,
  UNMARK_GRAY,
  LIMIT,
  NONE = LIMIT,
  EXPLICIT_SUSPENSION = LIMIT,
  IMPLICIT_SUSPENSION
};

static const size_t MAX_PHASE_NESTING = 4;
