struct debug_color_common {
struct Samplers {
 bool set_slot(int index, int value) {
  switch (index) {
  }
  return false;
 }
} samplers;
struct AttribLocations {
 int aPosition = NULL_ATTRIB;
 int aColor = NULL_ATTRIB;
 void bind_loc(const char* name, int index) {
  if (strcmp("aPosition", name) == 0) { aPosition = index; return; }
  if (strcmp("aColor", name) == 0) { aColor = index; return; }
 }
 int get_loc(const char* name) const {
  if (strcmp("aPosition", name) == 0) { return aPosition != NULL_ATTRIB ? aPosition : -1; }
  if (strcmp("aColor", name) == 0) { return aColor != NULL_ATTRIB ? aColor : -1; }
  return -1;
 }
} attrib_locations;
mat4_scalar uTransform;
void bind_textures() {
}
};
struct debug_color_vert : VertexShaderImpl, debug_color_common {
private:
typedef debug_color_vert Self;
// int32_t uMode;
// mat4_scalar uTransform;
vec2 aPosition;
vec4 vColor;
vec4 aColor;
ALWAYS_INLINE void main(void) {
 vColor = make_vec4(((aColor).sel(R, G, B))*((aColor).sel(A)), (aColor).sel(A));
 vec4 pos = make_vec4(aPosition, 0.f, 1.f);
 (pos).lsel(X, Y) = floor(((pos).sel(X, Y))+(0.5f));
 gl_Position = (uTransform)*(pos);
}
static void set_uniform_1i(Self *self, int index, int value) {
 if (self->samplers.set_slot(index, value)) return;
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  assert(0); // uTransform
  break;
 }
}
static void set_uniform_matrix4fv(Self *self, int index, const float *value) {
 switch (index) {
 case 1:
  self->uTransform = mat4_scalar::load_from_ptr(value);
  break;
 }
}
static void load_attribs(Self *self, VertexAttrib *attribs, uint32_t start, int instance, int count) {
 load_attrib(self->aPosition, attribs[self->attrib_locations.aPosition], start, instance, count);
 load_attrib(self->aColor, attribs[self->attrib_locations.aColor], start, instance, count);
}
public:
struct InterpOutputs {
vec4_scalar vColor;
};
private:
ALWAYS_INLINE void store_interp_outputs(char* dest_ptr, size_t stride) {
  for(int n = 0; n < 4; n++) {
    auto* dest = reinterpret_cast<InterpOutputs*>(dest_ptr);
    dest->vColor = get_nth(vColor, n);
    dest_ptr += stride;
  }
}
static void run(Self* self, char* interps, size_t interp_stride) {
 self->main();
 self->store_interp_outputs(interps, interp_stride);
}
static void init_batch(Self *self) { self->bind_textures(); }
public:
debug_color_vert() {
 set_uniform_1i_func = (SetUniform1iFunc)&set_uniform_1i;
 set_uniform_4fv_func = (SetUniform4fvFunc)&set_uniform_4fv;
 set_uniform_matrix4fv_func = (SetUniformMatrix4fvFunc)&set_uniform_matrix4fv;
 init_batch_func = (InitBatchFunc)&init_batch;
 load_attribs_func = (LoadAttribsFunc)&load_attribs;
 run_primitive_func = (RunPrimitiveFunc)&run;
}
};


struct debug_color_frag : FragmentShaderImpl, debug_color_vert {
private:
typedef debug_color_frag Self;
#define oFragColor gl_FragColor
// vec4 oFragColor;
vec4 vColor;
ALWAYS_INLINE void main(void) {
 oFragColor = vColor;
}
typedef debug_color_vert::InterpOutputs InterpInputs;
InterpInputs interp_step;
struct InterpPerspective {
vec4 vColor;
};
InterpPerspective interp_perspective;
static void read_interp_inputs(Self *self, const InterpInputs *init, const InterpInputs *step) {
  self->vColor = init_interp(init->vColor, step->vColor);
  self->interp_step.vColor = step->vColor * 4.0f;
}
static void read_perspective_inputs(Self *self, const InterpInputs *init, const InterpInputs *step) {
  Float w = 1.0f / self->gl_FragCoord.w;
  self->interp_perspective.vColor = init_interp(init->vColor, step->vColor);
  self->vColor = self->interp_perspective.vColor * w;
  self->interp_step.vColor = step->vColor * 4.0f;
}
ALWAYS_INLINE void step_interp_inputs(int steps = 4) {
  float chunks = steps * 0.25f;
  vColor += interp_step.vColor * chunks;
}
ALWAYS_INLINE void step_perspective_inputs(int steps = 4) {
  step_perspective(steps);
  float chunks = steps * 0.25f;
  Float w = 1.0f / gl_FragCoord.w;
  interp_perspective.vColor += interp_step.vColor * chunks;
  vColor = w * interp_perspective.vColor;
}
static void run(Self *self) {
 self->main();
 self->step_interp_inputs();
}
static void skip(Self* self, int steps) {
 self->step_interp_inputs(steps);
}
static void run_perspective(Self *self) {
 self->main();
 self->step_perspective_inputs();
}
static void skip_perspective(Self* self, int steps) {
 self->step_perspective_inputs(steps);
}
public:
debug_color_frag() {
 init_span_func = (InitSpanFunc)&read_interp_inputs;
 run_func = (RunFunc)&run;
 skip_func = (SkipFunc)&skip;
 enable_perspective();
 init_span_w_func = (InitSpanWFunc)&read_perspective_inputs;
 run_w_func = (RunWFunc)&run_perspective;
 skip_w_func = (SkipWFunc)&skip_perspective;
}
};

struct debug_color_program : ProgramImpl, debug_color_frag {
int get_uniform(const char *name) const override {
 if (strcmp("uTransform", name) == 0) { return 1; }
 return -1;
}
void bind_attrib(const char* name, int index) override {
 attrib_locations.bind_loc(name, index);
}
int get_attrib(const char* name) const override {
 return attrib_locations.get_loc(name);
}
size_t interpolants_size() const override { return sizeof(InterpOutputs); }
VertexShaderImpl* get_vertex_shader() override {
 return this;
}
FragmentShaderImpl* get_fragment_shader() override {
 return this;
}
const char* get_name() const override { return "debug_color"; }
static ProgramImpl* loader() { return new debug_color_program; }
};

